//
// Ή~쐬
//
// written by T.Noda
//
//  2001/11/30 Ver 0.0.1 Ή~
//  2001/12/05 Ver 0.0.2 ͂ꂽã`FbN
//
// D:a H: ΐS:L
// dang: px
//
//************************************
//
//  f[^ւ
//
//************************************
procedure SwapValue(var SA : double; var EA : double);
var
  temp : double;
begin
  temp := SA;
  SA := EA;
  EA := temp;
end;
//************************************
//
//  a擾
//
//************************************
function RadiusGet(px1 : double; py1 : double; px2 : double; py2 : double; px3 : double; py3 : double) : double;
var
  L1, L2, L3 : double;
begin
  L1 := Distance(px1, py1, px2, py2);
  L2 := Distance(px2, py2, px3, py3);
  L3 := Distance(px3, py3, px1, py1);
  Result := 0.5*L2/(sin(ArcCos((L1*L1+L3*L3-L2*L2)/(2.0*L1*L3))));
end;
//************************************
//
//  SW擾
//
//************************************
procedure CenterPointGet(var x0 : double; var y0 : double; x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double);
var
  a1, a2, b1, b2, xm1, ym1, xm2, ym2, ang1, ang2 : double;
  flg1, flg2 : boolean;
begin
  xm1 := 0.5*(x1+x2);  // _擾
  ym1 := 0.5*(y1+y2);
  xm2 := 0.5*(x2+x3);
  ym2 := 0.5*(y2+y3);
  ang1 := PosToAngl(x1, y1, x2, y2)+90.0;
  if ang1 > 360.0 then
  begin
    ang1 := ang1-360.0;
  end;
  ang2 := PosToAngl(x2, y2, x3, y3)+90.0;
  if ang2 > 360.0 then
  begin
    ang2 := ang2-360.0;
  end;
  if (ang1=90.0)OR(ang1=270.0) then
  begin
    x0 := xm1;
    flg1 := true;
  end
  else
  begin
    a1 := tan(ang1);
    b1 := ym1-a1*xm1;
    flg1 := false;
  end;
  if (ang2=90.0)OR(ang2=270.0) then
  begin
    x0 := xm2;
    flg2 := true;
  end
  else
  begin
    a2 := tan(ang2);
    b2 := ym2-a2*xm2;
    flg2 := false;
  end;
  if flg1 = true then
  begin
    y0 := a2*x0+b2;
  end
  else if flg2 = true then
  begin
    y0 := a1*x0+b1;
  end
  else
  begin
    x0 := -(b2-b1)/(a2-a1);
    y0 := -(a1*b2-a2*b1)/(a2-a1);
  end;
end;
//************************************
//
//  ~ʕԕ` 2001/07/19
//
//************************************
procedure PrintArc(x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double; xm : double);
var
  x0, y0, r, SA, EA : double;
begin
  r := RadiusGet(x1, y1, x2, y2, x3, y3);
  CenterPointGet(x0, y0, x1, y1, x2, y2, x3, y3);
  SA := PosToAngl(x0, y0, x1, y1);
  EA := PosToAngl(x0, y0, x3, y3);
  if EA < SA then
    begin
      SwapValue(SA, EA);
    end;
  if Abs(EA-SA) > 180.0 then
    begin
      SwapValue(SA, EA);
    end;
  AnglCheck(SA, EA);
  Arc(x0, y0, r, SA, EA);
  x0 := 2.0*xm-x0;
  SA := 540.0-SA;
  EA := 540.0-EA;
  Arc(x0, y0, r, EA, SA);
end;
//************************************
//
//  CvO
//
//************************************
Program SLANTCONE;
var
  x, y : Array of double;
  base, ang, bang, dang, dist1, dist2, radius, D, H, L : double;
  i, LoopCnt : integer;

Begin
  dang := 7.5;  // ύXƕω܂
  LoopCnt := int(180.0/dang);
  AddImage(20, 20, 'Ή~PARAM.BMP');

  AddLabel(130, 23, 95, 13, 'a(D)');
  AddLabel(130, 53, 95, 13, '(H)');
  AddLabel(130, 83, 95, 13, 'ΐS(L)');
  AddCheckBox(1, 130, 110, true, '⏕}'); // `FbN{bNX

  AddEdit(1, 200, 20, 50, 21, '');
  AddEdit(2, 200, 50, 50, 21, '');
  AddEdit(3, 200, 80, 50, 21, '');

  while true do
  begin
    if ShowDlg(280, 180,'Ή~}_CAO') <> True Then
      Exit;
    D := StrToFloat(GetDlgText(1)); // ɕϊ
    H := StrToFloat(GetDlgText(2));
    L := StrToFloat(GetDlgText(3));
    if D <= 0.0 then
    begin
      OkMsgBox('a𐳂͂ĉ');
    end
    else
    begin
      break;
    end;
  end;
  SetArrayLength(x, 6);
  SetArrayLength(y, 6);
  Message('zuʒu͂ĉB');
  if GetPos(x[0], y[0]) = false then
  begin
    exit;
  end;
  dist2 := D*Pi*dang/360.0;
  radius := 0.5*D;
  base := Sqrt((H*H)+(L+radius)*(L+radius));
  dist1 := Sqrt((H*H)+(L+radius*Cos(dang))*(L+radius*Cos(dang))+(radius*Sin(dang))*(radius*Sin(dang)));
  ang := 0.0;
  bang := ArcCos(0.5*(base*base+dist1*dist1-dist2*dist2)/base/dist1);
  for i:=0 to LoopCnt do
  begin
    dist1 := Sqrt((H*H)+(L+radius*Cos(i*dang))*(L+radius*Cos(i*dang))+(radius*Sin(i*dang))*(radius*Sin(i*dang)));
    ang := ang+bang;
    if i = 0 then
    begin
      x[1] := x[0];
      y[1] := y[0] + dist1;
      ang := ang-bang;
      if CheckBoxChecked(1) then
      begin
        LineType(3);  // iP_j
        PenNo(1)
        Line(x[0], y[0], x[1], y[1]);
      end;
    end
    else if (i mod 2) = 1 then
    begin
      x[2] := x[0]+dist1*Sin(ang);
      y[2] := y[0]+dist1*Cos(ang);
    end
    else
    begin
      x[3] := x[0]+dist1*Sin(ang);
      y[3] := y[0]+dist1*Cos(ang);
      if (CheckBoxChecked(1)) AND (i<>LoopCnt) then
      begin
        LineType(2);// i_j
        PenNo(1)
        Line(x[0], y[0], x[3], y[3]);
        Line(x[0], y[0], x[0]-dist1*Sin(ang), y[3]);
      end;
      LineType(0);  // ij
      PenNo(1)
      PrintArc(x[1], y[1], x[2], y[2], x[3], y[3], x[0]);
      x[1] := x[3];
      y[1] := y[3];
    end;
  end;
  Line(x[0], y[0], x[3], y[3]);
  Line(x[0], y[0], x[0]-dist1*Sin(ang), y[3]);
End.
